%% Main function for Angle measurement error mean value for roll and pitch noises
%% Parameter configuration:
% MATLABR2014a   windows 7 x64-based PC

% The direction of the rotation axis is set as gamma=40 degree.
%The noise level of the roll_alpha and pitch_alpha is set as zero mean
%gaussian noises with amplitude of 0.1, 0.3, 0.5,1.9 (unit: degree)
%

%% Notice: The file runs at MATLABR2014a more than an hour.

%% 

%
clear all;
clc
tic
N_experiment =1000;%experiment times
N_axis = 5;%gamma=40degree
N_noise = 10;% the number of the noise level
% n_noise_axis=0.1;%
alpha_e = zeros(N_experiment*N_noise,301);

%% 
for n_axis = 5:N_axis
for n_noise = 1:N_noise
for n_experiment = 1:N_experiment
% 
r = [0 1 tan(10*(N_axis-1)/180*pi)];% The direction of rotation axis gamma= 40 degree
%r = [0 0 1];
r = r/norm(r);
% 
tRw = Rotation(pi*(1-2*rand()),pi*(1-2*rand()),pi*(1-2*rand()));%The rotation matrix from {W} to {I0} is represented by three random attitude angle
%tRw = Rotation(0.5,0.2,0.3);
%% 

%
alpha = -180:0.1:180;
n = max(size(alpha));
x = zeros(3,n);

% 

axis_n=tRw*r'/norm(tRw*r',2);


for i=1:n
    R = axis_angletoq2R(axis_n,alpha(i));%The rotation matrix from {W} to {I0} is represented by a quaternion consisting of the direction of the rotation axis and its rotation angle.
    x(:,i) = R*tRw*[0 0 1]';% three curves (three sets) x y z
end

%% Solve the corresponding attitude angle phi_ra and theta_ra and add observation noise to them.
for n_angle = 1:301
ra = -150+(n_angle-1);% choose a rotation angle ra from the interval [-5/6*pi 5/6*pi] and take it as the angle to measure.
temp = axis_angletoq2R(tRw*r',ra)*tRw*[0 0 1]';

phi = atand(temp(2)/temp(3));
theta = sign(temp(1))*acosd(temp(2)/sin(phi/180*pi));

phi = phi + (n_noise*0.2-0.1)/3*randn();
theta = theta + (n_noise*0.2-0.1)/3*randn();

%% 
xc = [sin(theta/180*pi) cos(theta/180*pi)*sin(phi/180*pi) cos(theta/180*pi)*cos(phi/180*pi)];
%Ne Ae and Ke are matrix with three rows (three rows corresponds to the corresponding variables of x y z) and denote the number of the solution, 
%the estimates of the rotation angle and the corresponding slopes, respectively. 
Ne = zeros(3,1);
Ae = zeros(3,5);
Ke = zeros(3,5);
for k=1:3 
    x_temp = x(k,:);
    minmax_x = minmax(x_temp);
    if xc(k)>minmax_x(2)
        for i=2:(n-1)
            if (x_temp(i)-x_temp(i-1))>=0&&(x_temp(i+1)-x_temp(i))<=0
                Ne(k) = Ne(k) + 1;
                Ae(k,Ne(k)) = alpha(i);
                Ke(k,Ne(k)) = 0.000001;
            end
        end
    elseif xc(k)>=minmax_x(1)
        for i=1:(n-1)
            if (xc(k)-x_temp(i))*(xc(k)-x_temp(i+1))<=0
                Ne(k) = Ne(k) +1;
                Ae(k,Ne(k)) = (xc(k)-x_temp(i))/(x_temp(i+1)-x_temp(i))*(alpha(i+1)-alpha(i))+alpha(i);
                Ke(k,Ne(k)) = (x_temp(i+1)-x_temp(i))/(alpha(i+1)-alpha(i));
            end
        end
    else
        for i=2:(n-1)
            if (x_temp(i)-x_temp(i-1))<=0&&(x_temp(i+1)-x_temp(i))>=0
                Ne(k) = Ne(k) + 1;
                Ae(k,Ne(k)) = alpha(i);
                Ke(k,Ne(k)) = 0.000001;
            end
        end
    end
    if Ne(k) == 0
       Ne(k) = 1;
       Ae(k,Ne(k)) = 180;
       Ke(k,Ne(k)) = 0.0000001;
    end
end
Ni = 0; Nj = 0; Nk = 0;
fmin = 360*3;
for i = 1:Ne(1)
    for j=1:Ne(2)
        for k = 1:Ne(3)
            a1 = abs(Ae(1,i)-Ae(2,j));
            a2 = abs(Ae(1,i)-Ae(3,k));
            a3 = abs(Ae(3,k)-Ae(2,j));
            if a1>180
               a1 = 360 - a1;
            end
            if a2>180
               a2 = 360 - a2;
            end
            if a3>180
               a3 = 360 - a3;
            end
            if (a1+a2+a3)<fmin
                Ni = i;
                Nj = j;
                Nk = k;
                fmin = a1+a2+a3;
            end
        end
    end
end
%ra
%ra_est=abs(Ke(1,Ni))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(1,Ni)+abs(Ke(2,Nj))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(2,Nj)+abs(Ke(3,Nk))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(3,Nk)

% calculate the optimal estimate of ra and its measurement error a
a = abs(Ke(1,Ni))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(1,Ni)+abs(Ke(2,Nj))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(2,Nj)+abs(Ke(3,Nk))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(3,Nk)-ra

if a>180
   a = 360 - a;
elseif a<-180
   a = 360 + a;
end
alpha_e(n_experiment+(n_noise-1)*N_experiment,n_angle) = a;

end


end
n_experiment+(n_noise-1)*N_experiment
end
end
toc
save alpha_e alpha_e

