%% Main function for Angle measurement error mean value for different axes with the noise changing
%% Parameter configuration:
% MATLABR2014a   windows 7 x64-based PC

% The observation noise of phi_alpha and theta_alpha is set as zero mean gaussian noises with amplitude varying from 0 degree to 4 degree by the step 0.1 degree.
% The direction of rotation axis gamma is set as 0, 10, 20,,80(unit: degree).

%% Notice: The file runs at MATLABR2014a more than an hour.
clear all;
clc

tic
N_experiment = 100; % experiment times 
N_axis = 9; %The number of the rotation axes
alpha_e1 = zeros(N_experiment,76);% A matrix is used for saving the measurement error of the rotation angle.
mean_n=zeros(41,N_axis);

for n_axis = 1:N_axis
%     n_axis
for n_noise =0:0.1:4;%The observation noise of phi_alpha and theta_alpha
    n_noise
for n_experiment = 1:N_experiment
% ????
% n_axis
r = [0 1 tan(10*(n_axis-1)/180*pi)];% The direction of rotation axis gamma= 0 10 2080 degree
%r = [0 0 1];
r = r/norm(r);

tRw = Rotation(pi*(1-2*rand()),pi*(1-2*rand()),pi*(1-2*rand()));% The rotation matrix from {W} to {I0} is represented by three random attitude angle
%tRw = Rotation(0.5,0.2,0.3);
%% 

%????
alpha = -180:0.1:180;%
n = max(size(alpha));% 361
x = zeros(3,n);

% ??????

axis_n=tRw*r'/norm(tRw*r',2);


for i=1:n
    R = axis_angletoq2R(axis_n,alpha(i));%The rotation matrix from {W} to {I0} is represented by a quaternion consisting of the direction of the rotation axis and its rotation angle.
    x(:,i) = R*tRw*[0 0 1]';% three curves (three sets) x y z
end


for n_angle = 1:4:301
ra = -150+(n_angle-1);% choose a rotation angle ra from the interval [-5/6*pi 5/6*pi] and take it as the angle to measure.
% solve the corresponding attitude angle phi_ra and theta_ra and  add
% observation noise to them.
temp = axis_angletoq2R(tRw*r',ra)*tRw*[0 0 1]';

phi = atand(temp(2)/temp(3));
theta = sign(temp(1))*acosd(temp(2)/sin(phi/180*pi));

phi = phi + n_noise*randn();%
theta = theta + n_noise*randn();

%% Solve the rotation angle with respect to ra (attitude angle phi_ra and theta_ra) by interpolation.
xc = [sin(theta/180*pi) cos(theta/180*pi)*sin(phi/180*pi) cos(theta/180*pi)*cos(phi/180*pi)];
%Ne Ae and Ke are matrix with three rows (three rows corresponds to the corresponding variables of x y z) and denote the number of the solution, 
%the estimates of the rotation angle and the corresponding slopes, respectively. 
Ne = zeros(3,1);%
Ae = zeros(3,5);%
Ke = zeros(3,5);%
for k=1:3
    x_temp = x(k,:);
    minmax_x = minmax(x_temp);%
    if xc(k)>minmax_x(2)%
        for i=2:(n-1)%n361
            if (x_temp(i)-x_temp(i-1))>=0&&(x_temp(i+1)-x_temp(i))<=0
                Ne(k) = Ne(k) + 1;
                Ae(k,Ne(k)) = alpha(i);
                Ke(k,Ne(k)) = 0.0000001;
            end
        end
    elseif xc(k)>=minmax_x(1)%
        for i=1:(n-1)
            if (xc(k)-x_temp(i))*(xc(k)-x_temp(i+1))<=0
                Ne(k) = Ne(k) +1;
                Ae(k,Ne(k)) = (xc(k)-x_temp(i))/(x_temp(i+1)-x_temp(i))*(alpha(i+1)-alpha(i))+alpha(i);
                Ke(k,Ne(k)) = (x_temp(i+1)-x_temp(i))/(alpha(i+1)-alpha(i));
            end
        end
    else%
        for i=2:(n-1)
            if (x_temp(i)-x_temp(i-1))<=0&&(x_temp(i+1)-x_temp(i))>=0
                Ne(k) = Ne(k) + 1;
                Ae(k,Ne(k)) = alpha(i);
                Ke(k,Ne(k)) = 0.0000001;
            end
        end
    end
    if Ne(k) == 0 
       Ne(k) = 1;
       Ae(k,Ne(k)) = 180;
       Ke(k,Ne(k)) = 0.0000001;
    end
end


%% Search for the optimal estimates of the rotation angle in each curve(x y z) from Ae
Ni = 0; Nj = 0; Nk = 0;%
fmin = 360*3;
for i = 1:Ne(1)
    for j=1:Ne(2)
        for k = 1:Ne(3) %a1 a2 a3 
            a1 = abs(Ae(1,i)-Ae(2,j));
            a2 = abs(Ae(1,i)-Ae(3,k));
            a3 = abs(Ae(3,k)-Ae(2,j));
            if a1>180
               a1 = 360 - a1;
            end
            if a2>180
               a2 = 360 - a2;
            end
            if a3>180
               a3 = 360 - a3;
            end
            if (a1+a2+a3)<fmin
                Ni = i;
                Nj = j;
                Nk = k;
                fmin = a1+a2+a3;
            end
        end
    end
end
%a 
a = abs(Ke(1,Ni))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(1,Ni)+abs(Ke(2,Nj))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(2,Nj)+abs(Ke(3,Nk))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(3,Nk)-ra

if a>180
   a = 360 - a;
elseif a<-180
   a = 360 + a;
end

alpha_e1(n_experiment,floor(n_angle/4)+1) = abs(a);%

end

%save alpha_e1 alpha_e1 %save the measurement error matrix e1
mean_n(floor(n_noise*10)+1,n_axis)=mean(mean(alpha_e1,1),2);
end
 
end

end

save mean_n mean_n;%the mean error of the rotation angle of a rotation axis in a noise level of roll_alpha and pitch_alpha
% 
toc
% 
% figure(1)
% plot(0:0.1:4,mean_n(1:41,1),'r')
% hold on
% % plot(0:0.1:4,mean_n(1:41,2),'g')
% % hold on
% % plot(0:0.1:4,mean_n(1:41,3),'b')
% % hold on
% % plot(0:0.1:4,mean_n(1:41,4),'k')
% % hold on
% plot(0:0.1:4,mean_n(1:41,5),'m')
% hold on
% plot(0:0.1:4,mean_n(1:41,6),'c')
% hold on
% plot(0:0.1:4,mean_n(1:41,7),'r')
% hold on
% plot(0:0.1:4,mean_n(1:41,8),'g')
% hold on
% plot(0:0.1:4,mean_n(1:41,9),'b')






