function axis=axis_meanshift_me(x,p0,q0,r0)
% This function uses mean-shift algorithm to solve the direction of the
% rotation axis.
%input:
% x: the data of the body angular rates
% p0 q0 and r0 are the angular rate static error of the IMU
%output: axis :the direction of the rotation axis.
bandwidth = 0.75
n=size(x,1);
data=[x-[p0*ones(n,1),q0*ones(n,1),r0*ones(n,1)]];
for i=1:n
    if data(i,1)<0
        data(i,:)=-data(i,:);
    else
    end
end
x=data';
% tic
[clustCent,point2cluster,clustMembsCell] = MeanShiftCluster(x,bandwidth);%
% toc

numClust = length(clustMembsCell);

figure(1)%,clf,hold on
cVec = 'bgrcmykbgrcmykbgrcmykbgrcmyk';%, cVec = [cVec cVec];  
for k = 1:min(numClust,length(cVec))
    myMembers = clustMembsCell{k};%
    myClustCen = clustCent(:,k);%
    plot3(x(1,myMembers),x(2,myMembers),x(3,myMembers),[cVec(k) '.'])
     hold on
    plot3(myClustCen(1),myClustCen(2),myClustCen(3),'o','MarkerEdgeColor','r','MarkerFaceColor',cVec(k), 'MarkerSize',10)
    hold on
end
title(['numClust:' int2str(numClust)])

% ax=clustCent(:,1);

axis = clustCent(:,1);%[p q r];
axis = axis/norm(axis);% 

