function a=xc2a(roll,pitch,alpha,x,n)
% This a interpolation function. With the observation roll and pitch, solve
% the interpolation rotation angle a in three curves.
%input:
% roll and pitch : the observation of attitude angles at {I_alpha}
% alpha = -180:0.1:180;
% n = max(size(alpha));



xc = [-sin(pitch) cos(pitch)*sin(roll) cos(pitch)*cos(roll)];
Ne = zeros(3,1);
Ae = zeros(3,5);
Ke = zeros(3,5);
for k=1:3 
    x_temp = x(k,:);
    minmax_x = minmax(x_temp);
    if xc(k)>minmax_x(2)%
        for i=2:(n-1)
            if (x_temp(i)-x_temp(i-1))>=0&&(x_temp(i+1)-x_temp(i))<=0
                Ne(k) = Ne(k) + 1;
                Ae(k,Ne(k)) = alpha(i);
                Ke(k,Ne(k)) = 0.000001;
            end
        end
    elseif xc(k)>=minmax_x(1)
        for i=1:(n-1)
            if (xc(k)-x_temp(i))*(xc(k)-x_temp(i+1))<=0
                Ne(k) = Ne(k) +1;
                Ae(k,Ne(k)) = (xc(k)-x_temp(i))/(x_temp(i+1)-x_temp(i))*(alpha(i+1)-alpha(i))+alpha(i);
                Ke(k,Ne(k)) = (x_temp(i+1)-x_temp(i))/(alpha(i+1)-alpha(i));
            end
        end
    else
        for i=2:(n-1)
            if (x_temp(i)-x_temp(i-1))<=0&&(x_temp(i+1)-x_temp(i))>=0
                Ne(k) = Ne(k) + 1;
                Ae(k,Ne(k)) = alpha(i);
                Ke(k,Ne(k)) = 0.000001;
            end
        end
    end
    if Ne(k) == 0%
       Ne(k) = 1;
       Ae(k,Ne(k)) = 180;
       Ke(k,Ne(k)) = 0.0000001;
    end
end
% Ne
Ni = 0; Nj = 0; Nk = 0;
fmin = 360*3;
for i = 1:Ne(1)
    for j=1:Ne(2)
        for k = 1:Ne(3)
            a1 = abs(Ae(1,i)-Ae(2,j));
            a2 = abs(Ae(1,i)-Ae(3,k));
            a3 = abs(Ae(3,k)-Ae(2,j));
            if a1>180
               a1 = 360 - a1;
            end
            if a2>180
               a2 = 360 - a2;
            end
            if a3>180
               a3 = 360 - a3;
            end
            if (a1+a2+a3)<fmin
                Ni = i;
                Nj = j;
                Nk = k;
                fmin = a1+a2+a3;
            end
        end
    end
end
% Ni
alphax=Ae(1,Ni);
% Nj
alphay=Ae(2,Nj);
% Nk
alphaz=Ae(3,Nk);
a= abs(Ke(1,Ni))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(1,Ni)+abs(Ke(2,Nj))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(2,Nj)+abs(Ke(3,Nk))/(abs(Ke(1,Ni))+abs(Ke(2,Nj))+abs(Ke(3,Nk)))*Ae(3,Nk);
% roll



