function R=axis_angletoq2R(axis,angle)
%The rotation matrix from a state to another state is represented by a quaternion consisting of the direction of the rotation axis and its rotation angle

% input:
% axis:the direction of the rotation axis 
% angle:the rotation angle

%output:
% R: the rotation matrix
    axis = axis/norm(axis);
    angle = angle/180*pi;
    t = angle/2;
    q(1)=cos(t);
    q(2)=axis(1)*sin(t);
    q(3)=axis(2)*sin(t);
    q(4)=axis(3)*sin(t);
    R = qtorot(q);
end