%% This file is used to draw three curves to reveal the relationship between x y z and the rotation angle alpha.
% It is depicted in the paper named A Practical IMU-based Angle Measurement
% Method for a Single Axis Rotation.
%% Parameter configuration:
% MATLABR2014a   windows 7 x64-based PC
%%
clear all
clc
axis=[1 1 sqrt(2)]'/2% It can be set arbitrarily. Without loss of generality,the direction of the rotation axis is set as gamma = 45 degree.
angle=pi*[1-2*rand(),1-2*rand(),1-2*rand()];%The attitude angles at the initial state {I0} are randomly set.
tRw = Rotation(angle(1),angle(2),angle(3)); 
X=zeros(3,361);
% Selecting sample points alpha(i) from the interval [?pi, pi], generate
% three sets(three curves) x y z.
for i=1:361
    theta  = -180+(i-1);
    X(:,i) = axis_angletoq2R(tRw*axis,theta)*[0 0 1]';
end
% t=X(3,181)
subplot(3,1,1)
plot(-180:1:180,X(1,:),'r.');
ylabel('x')
subplot(3,1,2)
plot(-180:1:180,X(2,:),'g.');
ylabel('y')
subplot(3,1,3)
plot(-180:1:180,X(3,:),'b.');
xlabel('Rotation angle \alpha (deg)')
ylabel('z')